import type { Context, LogLevel, LogSink } from '@rocicorp/logger';
export interface DatadogLogSinkOptions {
    apiKey?: string | undefined;
    source?: string | undefined;
    service?: string | undefined;
    host?: string | undefined;
    version?: string | undefined;
    interval?: number | undefined;
    baseURL?: URL | undefined;
}
export declare const MAX_LOG_ENTRIES_PER_FLUSH = 1000;
export declare const FORCE_FLUSH_THRESHOLD = 250;
export declare const MAX_ENTRY_CHARS: number;
export declare class DatadogLogSink implements LogSink {
    #private;
    constructor(options: DatadogLogSinkOptions);
    log(level: LogLevel, context: Context | undefined, ...args: unknown[]): void;
    flush(): Promise<void>;
}
//# sourceMappingURL=datadog-log-sink.d.ts.map