import { type Hash } from '../hash.ts';
import * as KeyType from './key-type-enum.ts';
export declare function chunkDataKey(hash: Hash): string;
export declare function chunkMetaKey(hash: Hash): string;
export declare function chunkRefCountKey(hash: Hash): string;
export declare function headKey(name: string): string;
export type Key = {
    type: KeyType.ChunkData;
    hash: Hash;
} | {
    type: KeyType.ChunkMeta;
    hash: Hash;
} | {
    type: KeyType.ChunkRefCount;
    hash: Hash;
} | {
    type: KeyType.Head;
    name: string;
};
export declare function parse(key: string): Key;
//# sourceMappingURL=key.d.ts.map