type ErrorResponse = {
    error: string;
};
export declare function isErrorResponse(obj: object): obj is ErrorResponse;
/**
 * In certain scenarios the server can signal that it does not know about the
 * client. For example, the server might have lost all of its state (this might
 * happen during the development of the server).
 */
export type ClientStateNotFoundResponse = {
    error: 'ClientStateNotFound';
};
export declare function isClientStateNotFoundResponse(v: unknown): v is ClientStateNotFoundResponse;
/**
 * The server endpoint may respond with a `VersionNotSupported` error if it does
 * not know how to handle the pull, push or schema version.
 */
export type VersionNotSupportedResponse = {
    error: 'VersionNotSupported';
    versionType?: 'pull' | 'push' | 'schema' | undefined;
};
export declare function isVersionNotSupportedResponse(v: unknown): v is VersionNotSupportedResponse;
export declare function assertVersionNotSupportedResponse(v: unknown): asserts v is VersionNotSupportedResponse;
export {};
//# sourceMappingURL=error-responses.d.ts.map