import type { Read, Store, Write } from './store.ts';
export declare class IDBStore implements Store {
    #private;
    constructor(name: string);
    read(): Promise<Read>;
    write(): Promise<Write>;
    close(): Promise<void>;
    get closed(): boolean;
}
/**
 * This error is thrown when we detect that the IndexedDB has been removed. This
 * does not normally happen but can happen during development if the user has
 * DevTools open and deletes the IndexedDB from there.
 */
export declare class IDBNotFoundError extends Error {
    name: string;
}
//# sourceMappingURL=idb-store.d.ts.map