import type { Read, Store, Write } from './store.ts';
export declare function clearAllNamedMemStoresForTesting(): void;
export declare function dropMemStore(name: string): Promise<void>;
export declare function hasMemStore(name: string): boolean;
/**
 * A named in-memory Store implementation.
 *
 * Two (or more) named memory stores with the same name will share the same
 * underlying storage. They will also share the same read/write locks, so that
 * only one write transaction can be running at the same time.
 *
 * @experimental This class is experimental and might be removed or changed
 * in the future without following semver versioning. Please be cautious.
 */
export declare class MemStore implements Store {
    #private;
    constructor(name: string);
    read(): Promise<Read>;
    write(): Promise<Write>;
    close(): Promise<void>;
    get closed(): boolean;
}
//# sourceMappingURL=mem-store.d.ts.map