import type { ReadonlyJSONValue } from '../../../shared/src/json.ts';
import { type FrozenJSONValue } from '../frozen-json.ts';
import type { Read } from './store.ts';
export declare const deleteSentinel: unique symbol;
type DeleteSentinel = typeof deleteSentinel;
export declare class WriteImplBase {
    #private;
    protected readonly _pending: Map<string, FrozenJSONValue | DeleteSentinel>;
    constructor(read: Read);
    has(key: string): Promise<boolean>;
    get(key: string): Promise<FrozenJSONValue | undefined>;
    put(key: string, value: ReadonlyJSONValue): Promise<void>;
    del(key: string): Promise<void>;
    release(): void;
    get closed(): boolean;
}
export {};
//# sourceMappingURL=write-impl-base.d.ts.map