import { type ReadonlyJSONObject, type ReadonlyJSONValue } from '../../shared/src/json.ts';
export type PatchOperationInternal = {
    readonly op: 'put';
    readonly key: string;
    readonly value: ReadonlyJSONValue;
} | {
    readonly op: 'update';
    readonly key: string;
    readonly merge?: ReadonlyJSONObject | undefined;
    readonly constrain?: readonly string[] | undefined;
} | {
    readonly op: 'del';
    readonly key: string;
} | {
    readonly op: 'clear';
};
/**
 * This type describes the patch field in a {@link PullResponse} and it is used
 * to describe how to update the Replicache key-value store.
 */
export type PatchOperation = {
    readonly op: 'put';
    readonly key: string;
    readonly value: ReadonlyJSONValue;
} | {
    readonly op: 'del';
    readonly key: string;
} | {
    readonly op: 'clear';
};
export declare function assertPatchOperations(p: unknown): asserts p is PatchOperationInternal[];
//# sourceMappingURL=patch-operation.d.ts.map