import type { LogContext } from '@rocicorp/logger';
import type { Store } from '../dag/store.ts';
import { type ClientGroupMap } from './client-groups.ts';
import { type OnClientsDeleted } from './clients.ts';
export declare function getLatestGCUpdate(): Promise<ClientGroupMap> | undefined;
export declare function initClientGroupGC(dagStore: Store, enableMutationRecovery: boolean, onClientsDeleted: OnClientsDeleted, lc: LogContext, signal: AbortSignal): void;
/**
 * This removes client groups that have no clients and no pending mutations.
 * If {@linkcode enableMutationRecovery} is true, it will keep client groups with
 * pending mutations. If it is false, it will remove client groups even when they
 * have pending mutations.
 */
export declare function gcClientGroups(dagStore: Store, enableMutationRecovery: boolean, onClientsDeleted: OnClientsDeleted): Promise<ClientGroupMap>;
//# sourceMappingURL=client-group-gc.d.ts.map