import type { CreateStore } from '../kv/store.ts';
export type IndexedDBName = string;
export type IndexedDBDatabase = {
    readonly name: IndexedDBName;
    readonly replicacheName: string;
    readonly replicacheFormatVersion: number;
    readonly schemaVersion: string;
    readonly lastOpenedTimestampMS?: number;
};
export type IndexedDBDatabaseRecord = {
    readonly [name: IndexedDBName]: IndexedDBDatabase;
};
export declare class IDBDatabasesStore {
    #private;
    constructor(createKVStore: CreateStore);
    putDatabase(db: IndexedDBDatabase): Promise<IndexedDBDatabaseRecord>;
    putDatabaseForTesting(db: IndexedDBDatabase): Promise<IndexedDBDatabaseRecord>;
    clearDatabases(): Promise<void>;
    deleteDatabases(names: Iterable<IndexedDBName>): Promise<void>;
    getDatabases(): Promise<IndexedDBDatabaseRecord>;
    close(): Promise<void>;
    getProfileID(): Promise<string>;
}
//# sourceMappingURL=idb-databases-store.d.ts.map