export declare function assert(b: unknown, msg?: string | (() => string)): asserts b;
export declare function assertString(v: unknown): asserts v is string;
export declare function assertNumber(v: unknown): asserts v is number;
export declare function assertBoolean(v: unknown): asserts v is boolean;
export declare function assertObject(v: unknown): asserts v is Record<string, unknown>;
export declare function assertArray(v: unknown): asserts v is unknown[];
export declare function invalidType(v: unknown, t: string): string;
export declare function throwInvalidType(v: unknown, t: string): never;
export declare function assertNotNull<T>(v: T | null): asserts v is T;
export declare function assertUndefined<T>(v: T | undefined, msg?: string): asserts v is T;
export declare function assertNotUndefined<T>(v: T | undefined, msg?: string): asserts v is T;
export declare function assertInstanceof<T>(v: unknown, t: new (...args: unknown[]) => T): asserts v is T;
export declare function assertUint8Array(v: unknown): asserts v is Uint8Array;
export declare function unreachable(): never;
export declare function unreachable(v: never): never;
export declare function notImplemented(): never;
//# sourceMappingURL=asserts.d.ts.map