type Primitive = undefined | null | boolean | string | number | symbol | bigint;
/**
 * Create a deeply immutable type from a type that may contain mutable types.
 */
export type Immutable<T> = T extends Primitive ? T : T extends ReadonlyArray<infer U> ? ImmutableArray<U> : ImmutableObject<T>;
export type ImmutableArray<T> = ReadonlyArray<Immutable<T>>;
export type ImmutableObject<T> = {
    readonly [K in keyof T]: Immutable<T[K]>;
};
export {};
//# sourceMappingURL=immutable.d.ts.map