import { LogContext, } from '@rocicorp/logger';
export class TestLogSink {
    messages = [];
    flushCallCount = 0;
    log(level, context, ...args) {
        this.messages.push([level, context, args]);
    }
    flush() {
        this.flushCallCount++;
        return Promise.resolve();
    }
}
export class SilentLogSink {
    log(_l, _c, ..._args) {
        return;
    }
}
export function createSilentLogContext() {
    return new LogContext('error', undefined, new SilentLogSink());
}
//# sourceMappingURL=logging-test-utils.js.map