/**
 * Creates a promise that resolves after `ms` milliseconds. Note that if you
 * pass in `0` no `setTimeout` is used and the promise resolves immediately. In
 * other words no macro task is used in that case.
 *
 * Pass in an AbortSignal to clear the timeout.
 */
export declare function sleep(ms: number, signal?: AbortSignal): Promise<void>;
/**
 * Returns a pair of promises. The first promise resolves after `ms` milliseconds
 * unless the AbortSignal is aborted. The second promise resolves when the AbortSignal
 * is aborted.
 */
export declare function sleepWithAbort(ms: number, signal: AbortSignal): [ok: Promise<void>, aborted: Promise<void>];
//# sourceMappingURL=sleep.d.ts.map