import { LogContext } from '@rocicorp/logger';
import type { JWTPayload } from 'jose';
import type { CRUDOp, UpsertOp } from '../../../zero-protocol/src/push.ts';
import { Database } from '../../../zqlite/src/db.ts';
import type { ZeroConfig } from '../config/zero-config.ts';
export interface WriteAuthorizer {
    canPreMutation(authData: JWTPayload | undefined, ops: Exclude<CRUDOp, UpsertOp>[]): boolean;
    canPostMutation(authData: JWTPayload | undefined, ops: Exclude<CRUDOp, UpsertOp>[]): boolean;
    reloadPermissions(): void;
    normalizeOps(ops: CRUDOp[]): Exclude<CRUDOp, UpsertOp>[];
}
export declare class WriteAuthorizerImpl implements WriteAuthorizer {
    #private;
    constructor(lc: LogContext, config: ZeroConfig, replica: Database, appID: string, cgID: string);
    reloadPermissions(): void;
    canPreMutation(authData: JWTPayload | undefined, ops: Exclude<CRUDOp, UpsertOp>[]): boolean;
    canPostMutation(authData: JWTPayload | undefined, ops: Exclude<CRUDOp, UpsertOp>[]): boolean;
    normalizeOps(ops: CRUDOp[]): Exclude<CRUDOp, UpsertOp>[];
}
//# sourceMappingURL=write-authorizer.d.ts.map