import type { LogContext } from '@rocicorp/logger';
import { type LiteTypeString } from '../types/lite.ts';
import { type ColumnSpec, type IndexSpec, type LiteIndexSpec, type LiteTableSpec, type TableSpec } from './specs.ts';
export declare const ZERO_VERSION_COLUMN_SPEC: ColumnSpec;
export declare function warnIfDataTypeSupported(lc: LogContext, liteTypeString: LiteTypeString, table: string, column: string): void;
export declare function mapPostgresToLiteDefault(table: string, column: string, dataType: string, defaultExpression: string | null | undefined): string | null;
export declare function mapPostgresToLiteColumn(table: string, column: {
    name: string;
    spec: ColumnSpec;
}, ignoreDefault?: 'ignore-default'): ColumnSpec;
export declare function mapPostgresToLite(t: TableSpec): LiteTableSpec;
export declare function mapPostgresToLiteIndex(index: IndexSpec): LiteIndexSpec;
export declare class UnsupportedColumnDefaultError extends Error {
    readonly name = "UnsupportedColumnDefaultError";
}
//# sourceMappingURL=pg-to-lite.d.ts.map