import { HttpService } from "../../services/http-service.js";
import { handleStatzRequest } from "../../services/statz.js";
import { installWebSocketHandoff, } from "../../types/websocket-handoff.js";
export class ZeroDispatcher extends HttpService {
    id = 'zero-dispatcher';
    #getWorker;
    constructor(config, lc, opts, getWorker) {
        super(`zero-dispatcher`, lc, opts, fastify => {
            fastify.get('/statz', (req, res) => handleStatzRequest(config, req, res));
            installWebSocketHandoff(lc, this.#handoff, fastify.server);
        });
        this.#getWorker = getWorker;
    }
    #handoff = (_req, dispatch, onError) => {
        void this.#getWorker().then(receiver => dispatch({ payload: 'unused', receiver }), onError);
    };
}
//# sourceMappingURL=zero-dispatcher.js.map