import * as v from '../../../../../../shared/src/valita.ts';
declare const begin: v.TupleType<[v.Type<"begin">, v.ObjectType<{
    tag: v.Type<"begin">;
    json: v.Optional<"p" | "s">;
}, undefined>, v.ObjectType<{
    commitWatermark: v.Type<string>;
}, undefined>]>;
declare const data: v.TupleType<[v.Type<"data">, v.UnionType<[v.ObjectType<{
    tag: v.Type<"insert">;
    relation: v.ObjectType<{
        schema: v.Type<string>;
        name: v.Type<string>;
        keyColumns: v.ArrayType<v.Type<string>>;
        replicaIdentity: v.Optional<"default" | "nothing" | "full" | "index">;
    }, undefined>;
    new: v.Type<Record<string, import("../../../../types/bigint-json.ts").JSONValue>>;
}, undefined>, v.ObjectType<{
    tag: v.Type<"update">;
    relation: v.ObjectType<{
        schema: v.Type<string>;
        name: v.Type<string>;
        keyColumns: v.ArrayType<v.Type<string>>;
        replicaIdentity: v.Optional<"default" | "nothing" | "full" | "index">;
    }, undefined>;
    key: v.Type<Record<string, import("../../../../types/bigint-json.ts").JSONValue> | null>;
    new: v.Type<Record<string, import("../../../../types/bigint-json.ts").JSONValue>>;
}, undefined>, v.ObjectType<{
    tag: v.Type<"delete">;
    relation: v.ObjectType<{
        schema: v.Type<string>;
        name: v.Type<string>;
        keyColumns: v.ArrayType<v.Type<string>>;
        replicaIdentity: v.Optional<"default" | "nothing" | "full" | "index">;
    }, undefined>;
    key: v.Type<Record<string, import("../../../../types/bigint-json.ts").JSONValue>>;
}, undefined>, v.ObjectType<{
    tag: v.Type<"truncate">;
    relations: v.ArrayType<v.ObjectType<{
        schema: v.Type<string>;
        name: v.Type<string>;
        keyColumns: v.ArrayType<v.Type<string>>;
        replicaIdentity: v.Optional<"default" | "nothing" | "full" | "index">;
    }, undefined>>;
}, undefined>, v.ObjectType<{
    tag: v.Type<"create-table">;
    spec: v.ObjectType<Omit<{
        name: v.Type<string>;
        columns: v.Type<Record<string, {
            pgTypeClass?: "b" | "e" | "d" | "c" | "p" | "r" | "m" | undefined;
            characterMaximumLength?: number | null | undefined;
            notNull?: boolean | null | undefined;
            dflt?: string | null | undefined;
            pos: number;
            dataType: string;
        }>>;
        primaryKey: v.Optional<string[]>;
    }, "schema"> & {
        schema: v.Type<string>;
    }, undefined>;
}, undefined>, v.ObjectType<{
    tag: v.Type<"rename-table">;
    old: v.ObjectType<{
        schema: v.Type<string>;
        name: v.Type<string>;
    }, undefined>;
    new: v.ObjectType<{
        schema: v.Type<string>;
        name: v.Type<string>;
    }, undefined>;
}, undefined>, v.ObjectType<{
    tag: v.Type<"add-column">;
    table: v.ObjectType<{
        schema: v.Type<string>;
        name: v.Type<string>;
    }, undefined>;
    column: v.ObjectType<{
        name: v.Type<string>;
        spec: v.ObjectType<{
            pos: v.Type<number>;
            dataType: v.Type<string>;
            pgTypeClass: v.Optional<"b" | "e" | "d" | "c" | "p" | "r" | "m">;
            characterMaximumLength: v.Optional<number | null>;
            notNull: v.Optional<boolean | null>;
            dflt: v.Optional<string | null>;
        }, undefined>;
    }, undefined>;
}, undefined>, v.ObjectType<{
    tag: v.Type<"update-column">;
    table: v.ObjectType<{
        schema: v.Type<string>;
        name: v.Type<string>;
    }, undefined>;
    old: v.ObjectType<{
        name: v.Type<string>;
        spec: v.ObjectType<{
            pos: v.Type<number>;
            dataType: v.Type<string>;
            pgTypeClass: v.Optional<"b" | "e" | "d" | "c" | "p" | "r" | "m">;
            characterMaximumLength: v.Optional<number | null>;
            notNull: v.Optional<boolean | null>;
            dflt: v.Optional<string | null>;
        }, undefined>;
    }, undefined>;
    new: v.ObjectType<{
        name: v.Type<string>;
        spec: v.ObjectType<{
            pos: v.Type<number>;
            dataType: v.Type<string>;
            pgTypeClass: v.Optional<"b" | "e" | "d" | "c" | "p" | "r" | "m">;
            characterMaximumLength: v.Optional<number | null>;
            notNull: v.Optional<boolean | null>;
            dflt: v.Optional<string | null>;
        }, undefined>;
    }, undefined>;
}, undefined>, v.ObjectType<{
    tag: v.Type<"drop-column">;
    table: v.ObjectType<{
        schema: v.Type<string>;
        name: v.Type<string>;
    }, undefined>;
    column: v.Type<string>;
}, undefined>, v.ObjectType<{
    tag: v.Type<"drop-table">;
    id: v.ObjectType<{
        schema: v.Type<string>;
        name: v.Type<string>;
    }, undefined>;
}, undefined>, v.ObjectType<{
    tag: v.Type<"create-index">;
    spec: v.ObjectType<Omit<{
        name: v.Type<string>;
        tableName: v.Type<string>;
        unique: v.Type<boolean>;
        columns: v.Type<Record<string, "ASC" | "DESC">>;
    }, "schema"> & {
        schema: v.Type<string>;
    }, undefined>;
}, undefined>, v.ObjectType<{
    tag: v.Type<"drop-index">;
    id: v.ObjectType<{
        schema: v.Type<string>;
        name: v.Type<string>;
    }, undefined>;
}, undefined>]>]>;
declare const commit: v.TupleType<[v.Type<"commit">, v.ObjectType<{
    tag: v.Type<"commit">;
}, undefined>, v.ObjectType<{
    watermark: v.Type<string>;
}, undefined>]>;
declare const rollback: v.TupleType<[v.Type<"rollback">, v.ObjectType<{
    tag: v.Type<"rollback">;
}, undefined>]>;
export type Begin = v.Infer<typeof begin>;
export type Data = v.Infer<typeof data>;
export type Commit = v.Infer<typeof commit>;
export type Rollback = v.Infer<typeof rollback>;
export declare const changeStreamDataSchema: v.UnionType<[v.TupleType<[v.Type<"begin">, v.ObjectType<{
    tag: v.Type<"begin">;
    json: v.Optional<"p" | "s">;
}, undefined>, v.ObjectType<{
    commitWatermark: v.Type<string>;
}, undefined>]>, v.TupleType<[v.Type<"data">, v.UnionType<[v.ObjectType<{
    tag: v.Type<"insert">;
    relation: v.ObjectType<{
        schema: v.Type<string>;
        name: v.Type<string>;
        keyColumns: v.ArrayType<v.Type<string>>;
        replicaIdentity: v.Optional<"default" | "nothing" | "full" | "index">;
    }, undefined>;
    new: v.Type<Record<string, import("../../../../types/bigint-json.ts").JSONValue>>;
}, undefined>, v.ObjectType<{
    tag: v.Type<"update">;
    relation: v.ObjectType<{
        schema: v.Type<string>;
        name: v.Type<string>;
        keyColumns: v.ArrayType<v.Type<string>>;
        replicaIdentity: v.Optional<"default" | "nothing" | "full" | "index">;
    }, undefined>;
    key: v.Type<Record<string, import("../../../../types/bigint-json.ts").JSONValue> | null>;
    new: v.Type<Record<string, import("../../../../types/bigint-json.ts").JSONValue>>;
}, undefined>, v.ObjectType<{
    tag: v.Type<"delete">;
    relation: v.ObjectType<{
        schema: v.Type<string>;
        name: v.Type<string>;
        keyColumns: v.ArrayType<v.Type<string>>;
        replicaIdentity: v.Optional<"default" | "nothing" | "full" | "index">;
    }, undefined>;
    key: v.Type<Record<string, import("../../../../types/bigint-json.ts").JSONValue>>;
}, undefined>, v.ObjectType<{
    tag: v.Type<"truncate">;
    relations: v.ArrayType<v.ObjectType<{
        schema: v.Type<string>;
        name: v.Type<string>;
        keyColumns: v.ArrayType<v.Type<string>>;
        replicaIdentity: v.Optional<"default" | "nothing" | "full" | "index">;
    }, undefined>>;
}, undefined>, v.ObjectType<{
    tag: v.Type<"create-table">;
    spec: v.ObjectType<Omit<{
        name: v.Type<string>;
        columns: v.Type<Record<string, {
            pgTypeClass?: "b" | "e" | "d" | "c" | "p" | "r" | "m" | undefined;
            characterMaximumLength?: number | null | undefined;
            notNull?: boolean | null | undefined;
            dflt?: string | null | undefined;
            pos: number;
            dataType: string;
        }>>;
        primaryKey: v.Optional<string[]>;
    }, "schema"> & {
        schema: v.Type<string>;
    }, undefined>;
}, undefined>, v.ObjectType<{
    tag: v.Type<"rename-table">;
    old: v.ObjectType<{
        schema: v.Type<string>;
        name: v.Type<string>;
    }, undefined>;
    new: v.ObjectType<{
        schema: v.Type<string>;
        name: v.Type<string>;
    }, undefined>;
}, undefined>, v.ObjectType<{
    tag: v.Type<"add-column">;
    table: v.ObjectType<{
        schema: v.Type<string>;
        name: v.Type<string>;
    }, undefined>;
    column: v.ObjectType<{
        name: v.Type<string>;
        spec: v.ObjectType<{
            pos: v.Type<number>;
            dataType: v.Type<string>;
            pgTypeClass: v.Optional<"b" | "e" | "d" | "c" | "p" | "r" | "m">;
            characterMaximumLength: v.Optional<number | null>;
            notNull: v.Optional<boolean | null>;
            dflt: v.Optional<string | null>;
        }, undefined>;
    }, undefined>;
}, undefined>, v.ObjectType<{
    tag: v.Type<"update-column">;
    table: v.ObjectType<{
        schema: v.Type<string>;
        name: v.Type<string>;
    }, undefined>;
    old: v.ObjectType<{
        name: v.Type<string>;
        spec: v.ObjectType<{
            pos: v.Type<number>;
            dataType: v.Type<string>;
            pgTypeClass: v.Optional<"b" | "e" | "d" | "c" | "p" | "r" | "m">;
            characterMaximumLength: v.Optional<number | null>;
            notNull: v.Optional<boolean | null>;
            dflt: v.Optional<string | null>;
        }, undefined>;
    }, undefined>;
    new: v.ObjectType<{
        name: v.Type<string>;
        spec: v.ObjectType<{
            pos: v.Type<number>;
            dataType: v.Type<string>;
            pgTypeClass: v.Optional<"b" | "e" | "d" | "c" | "p" | "r" | "m">;
            characterMaximumLength: v.Optional<number | null>;
            notNull: v.Optional<boolean | null>;
            dflt: v.Optional<string | null>;
        }, undefined>;
    }, undefined>;
}, undefined>, v.ObjectType<{
    tag: v.Type<"drop-column">;
    table: v.ObjectType<{
        schema: v.Type<string>;
        name: v.Type<string>;
    }, undefined>;
    column: v.Type<string>;
}, undefined>, v.ObjectType<{
    tag: v.Type<"drop-table">;
    id: v.ObjectType<{
        schema: v.Type<string>;
        name: v.Type<string>;
    }, undefined>;
}, undefined>, v.ObjectType<{
    tag: v.Type<"create-index">;
    spec: v.ObjectType<Omit<{
        name: v.Type<string>;
        tableName: v.Type<string>;
        unique: v.Type<boolean>;
        columns: v.Type<Record<string, "ASC" | "DESC">>;
    }, "schema"> & {
        schema: v.Type<string>;
    }, undefined>;
}, undefined>, v.ObjectType<{
    tag: v.Type<"drop-index">;
    id: v.ObjectType<{
        schema: v.Type<string>;
        name: v.Type<string>;
    }, undefined>;
}, undefined>]>]>, v.TupleType<[v.Type<"commit">, v.ObjectType<{
    tag: v.Type<"commit">;
}, undefined>, v.ObjectType<{
    watermark: v.Type<string>;
}, undefined>]>, v.TupleType<[v.Type<"rollback">, v.ObjectType<{
    tag: v.Type<"rollback">;
}, undefined>]>]>;
export type ChangeStreamData = v.Infer<typeof changeStreamDataSchema>;
export declare const changeStreamControlSchema: v.TupleType<[v.Type<"control">, v.ObjectType<{
    tag: v.Type<"reset-required">;
    message: v.Optional<string>;
}, undefined>]>;
export type ChangeStreamControl = v.Infer<typeof changeStreamControlSchema>;
/** Downstream messages consist of data plane and control plane messages. */
export declare const changeStreamMessageSchema: v.UnionType<[v.UnionType<[v.TupleType<[v.Type<"begin">, v.ObjectType<{
    tag: v.Type<"begin">;
    json: v.Optional<"p" | "s">;
}, undefined>, v.ObjectType<{
    commitWatermark: v.Type<string>;
}, undefined>]>, v.TupleType<[v.Type<"data">, v.UnionType<[v.ObjectType<{
    tag: v.Type<"insert">;
    relation: v.ObjectType<{
        schema: v.Type<string>;
        name: v.Type<string>;
        keyColumns: v.ArrayType<v.Type<string>>;
        replicaIdentity: v.Optional<"default" | "nothing" | "full" | "index">;
    }, undefined>;
    new: v.Type<Record<string, import("../../../../types/bigint-json.ts").JSONValue>>;
}, undefined>, v.ObjectType<{
    tag: v.Type<"update">;
    relation: v.ObjectType<{
        schema: v.Type<string>;
        name: v.Type<string>;
        keyColumns: v.ArrayType<v.Type<string>>;
        replicaIdentity: v.Optional<"default" | "nothing" | "full" | "index">;
    }, undefined>;
    key: v.Type<Record<string, import("../../../../types/bigint-json.ts").JSONValue> | null>;
    new: v.Type<Record<string, import("../../../../types/bigint-json.ts").JSONValue>>;
}, undefined>, v.ObjectType<{
    tag: v.Type<"delete">;
    relation: v.ObjectType<{
        schema: v.Type<string>;
        name: v.Type<string>;
        keyColumns: v.ArrayType<v.Type<string>>;
        replicaIdentity: v.Optional<"default" | "nothing" | "full" | "index">;
    }, undefined>;
    key: v.Type<Record<string, import("../../../../types/bigint-json.ts").JSONValue>>;
}, undefined>, v.ObjectType<{
    tag: v.Type<"truncate">;
    relations: v.ArrayType<v.ObjectType<{
        schema: v.Type<string>;
        name: v.Type<string>;
        keyColumns: v.ArrayType<v.Type<string>>;
        replicaIdentity: v.Optional<"default" | "nothing" | "full" | "index">;
    }, undefined>>;
}, undefined>, v.ObjectType<{
    tag: v.Type<"create-table">;
    spec: v.ObjectType<Omit<{
        name: v.Type<string>;
        columns: v.Type<Record<string, {
            pgTypeClass?: "b" | "e" | "d" | "c" | "p" | "r" | "m" | undefined;
            characterMaximumLength?: number | null | undefined;
            notNull?: boolean | null | undefined;
            dflt?: string | null | undefined;
            pos: number;
            dataType: string;
        }>>;
        primaryKey: v.Optional<string[]>;
    }, "schema"> & {
        schema: v.Type<string>;
    }, undefined>;
}, undefined>, v.ObjectType<{
    tag: v.Type<"rename-table">;
    old: v.ObjectType<{
        schema: v.Type<string>;
        name: v.Type<string>;
    }, undefined>;
    new: v.ObjectType<{
        schema: v.Type<string>;
        name: v.Type<string>;
    }, undefined>;
}, undefined>, v.ObjectType<{
    tag: v.Type<"add-column">;
    table: v.ObjectType<{
        schema: v.Type<string>;
        name: v.Type<string>;
    }, undefined>;
    column: v.ObjectType<{
        name: v.Type<string>;
        spec: v.ObjectType<{
            pos: v.Type<number>;
            dataType: v.Type<string>;
            pgTypeClass: v.Optional<"b" | "e" | "d" | "c" | "p" | "r" | "m">;
            characterMaximumLength: v.Optional<number | null>;
            notNull: v.Optional<boolean | null>;
            dflt: v.Optional<string | null>;
        }, undefined>;
    }, undefined>;
}, undefined>, v.ObjectType<{
    tag: v.Type<"update-column">;
    table: v.ObjectType<{
        schema: v.Type<string>;
        name: v.Type<string>;
    }, undefined>;
    old: v.ObjectType<{
        name: v.Type<string>;
        spec: v.ObjectType<{
            pos: v.Type<number>;
            dataType: v.Type<string>;
            pgTypeClass: v.Optional<"b" | "e" | "d" | "c" | "p" | "r" | "m">;
            characterMaximumLength: v.Optional<number | null>;
            notNull: v.Optional<boolean | null>;
            dflt: v.Optional<string | null>;
        }, undefined>;
    }, undefined>;
    new: v.ObjectType<{
        name: v.Type<string>;
        spec: v.ObjectType<{
            pos: v.Type<number>;
            dataType: v.Type<string>;
            pgTypeClass: v.Optional<"b" | "e" | "d" | "c" | "p" | "r" | "m">;
            characterMaximumLength: v.Optional<number | null>;
            notNull: v.Optional<boolean | null>;
            dflt: v.Optional<string | null>;
        }, undefined>;
    }, undefined>;
}, undefined>, v.ObjectType<{
    tag: v.Type<"drop-column">;
    table: v.ObjectType<{
        schema: v.Type<string>;
        name: v.Type<string>;
    }, undefined>;
    column: v.Type<string>;
}, undefined>, v.ObjectType<{
    tag: v.Type<"drop-table">;
    id: v.ObjectType<{
        schema: v.Type<string>;
        name: v.Type<string>;
    }, undefined>;
}, undefined>, v.ObjectType<{
    tag: v.Type<"create-index">;
    spec: v.ObjectType<Omit<{
        name: v.Type<string>;
        tableName: v.Type<string>;
        unique: v.Type<boolean>;
        columns: v.Type<Record<string, "ASC" | "DESC">>;
    }, "schema"> & {
        schema: v.Type<string>;
    }, undefined>;
}, undefined>, v.ObjectType<{
    tag: v.Type<"drop-index">;
    id: v.ObjectType<{
        schema: v.Type<string>;
        name: v.Type<string>;
    }, undefined>;
}, undefined>]>]>, v.TupleType<[v.Type<"commit">, v.ObjectType<{
    tag: v.Type<"commit">;
}, undefined>, v.ObjectType<{
    watermark: v.Type<string>;
}, undefined>]>, v.TupleType<[v.Type<"rollback">, v.ObjectType<{
    tag: v.Type<"rollback">;
}, undefined>]>]>, v.TupleType<[v.Type<"control">, v.ObjectType<{
    tag: v.Type<"reset-required">;
    message: v.Optional<string>;
}, undefined>]>, v.TupleType<[v.Type<"status">, v.ObjectType<{}, undefined>, v.ObjectType<{
    watermark: v.Type<string>;
}, undefined>]>]>;
export type ChangeStreamMessage = v.Infer<typeof changeStreamMessageSchema>;
export {};
//# sourceMappingURL=downstream.d.ts.map