import { LogContext } from '@rocicorp/logger';
import { IncomingMessage } from 'node:http';
import { type Worker } from '../../types/processes.ts';
import type { ShardID } from '../../types/shards.ts';
import { type Source } from '../../types/streams.ts';
import { HttpService, type Options } from '../http-service.ts';
import type { BackupMonitor } from './backup-monitor.ts';
import { type ChangeStreamer, type Downstream, type SubscriberContext } from './change-streamer.ts';
import { type SnapshotMessage } from './snapshot.ts';
export declare class ChangeStreamerHttpServer extends HttpService {
    #private;
    readonly id = "change-streamer-http-server";
    constructor(lc: LogContext, opts: Options, parent: Worker);
    setDelegates(changeStreamer: ChangeStreamer, backupMonitor: BackupMonitor | null): void;
    protected _respondToKeepalive(): boolean;
}
export declare class ChangeStreamerHttpClient implements ChangeStreamer {
    #private;
    constructor(lc: LogContext, shardID: ShardID, changeDB: string);
    reserveSnapshot(taskID: string): Promise<Source<SnapshotMessage>>;
    subscribe(ctx: SubscriberContext): Promise<Source<Downstream>>;
}
type RequestHeaders = Pick<IncomingMessage, 'url' | 'headers'>;
export declare function getSubscriberContext(req: RequestHeaders): SubscriberContext;
export {};
//# sourceMappingURL=change-streamer-http.d.ts.map