import type { WatermarkedChange } from './change-streamer-service.ts';
import { Subscriber } from './subscriber.ts';
export declare class Forwarder {
    #private;
    /**
     * `add()` is called in lock step with `Storer.catchup()` so that the
     * two components have an equivalent interpretation of whether a Transaction is
     * currently being streamed.
     */
    add(sub: Subscriber): void;
    remove(sub: Subscriber): void;
    /**
     * `forward()` is called in lockstep with `Storer.store()` so that the
     * two components have an equivalent interpretation of whether a Transaction is
     * currently being streamed.
     */
    forward(entry: WatermarkedChange): void;
    getAcks(): Set<string>;
}
//# sourceMappingURL=forwarder.d.ts.map