/**
 * Definitions for the `snapshot` API, which serves the purpose of:
 * - informing subscribers (i.e. view-syncers) of the (litestream)
 *   backup location from which to restore a replica snapshot
 * - preventing change-log cleanup while a snapshot restore is in
 *   progress
 * - tracking the approximate time it takes from the beginning of
 *   snapshot "reservation" to the subsequent subscription, which
 *   serves as the minimum interval to wait before cleaning up
 *   backed up changes.
 */
import * as v from '../../../../shared/src/valita.ts';
declare const statusMessageSchema: v.TupleType<[v.Type<"status">, v.ObjectType<{
    tag: v.Type<"status">;
    backupURL: v.Type<string>;
}, undefined>]>;
export declare const snapshotMessageSchema: v.UnionType<[v.TupleType<[v.Type<"status">, v.ObjectType<{
    tag: v.Type<"status">;
    backupURL: v.Type<string>;
}, undefined>]>]>;
export type SnapshotMessage = v.Infer<typeof statusMessageSchema>;
export {};
//# sourceMappingURL=snapshot.d.ts.map