export type AppID = {
    readonly appID: string;
};
export type ShardID = AppID & {
    readonly shardNum: number;
};
export type ShardConfig = ShardID & {
    readonly publications: readonly string[];
};
export declare function getShardID({ app, shard, }: {
    app: {
        id: string;
    };
    shard: {
        num: number;
    };
}): ShardID;
export declare function getShardConfig({ app, shard, }: {
    app: {
        id: string;
        publications: string[];
    };
    shard: {
        num: number;
    };
}): ShardConfig;
export declare const ALLOWED_APP_ID_CHARACTERS: RegExp;
export declare const INVALID_APP_ID_MESSAGE = "The App ID may only consist of lower-case letters, numbers, and the underscore character";
export declare function check(shard: ShardID): {
    appID: string;
    shardNum: number;
};
export declare function appSchema({ appID }: AppID): string;
export declare function upstreamSchema(shard: ShardID): string;
export declare function cdcSchema(shard: ShardID): string;
export declare function cvrSchema(shard: ShardID): string;
//# sourceMappingURL=shards.d.ts.map