/**
 * Escapes the identifier with double quotes, as per:
 *
 * https://www.postgresql.org/docs/16/sql-syntax-lexical.html#SQL-SYNTAX-IDENTIFIERS
 */
export function id(name) {
    return '"' + name.replace(/"/g, '""') + '"'; //.replace(/\./g, '"."') + '"';
}
/**
 * Escapes and comma-separates a list of identifiers.
 */
export function idList(names) {
    return Array.from(names, name => id(name)).join(',');
}
//# sourceMappingURL=sql.js.map