class Transaction {
    wrappedTransaction;
    constructor(pgTx) {
        this.wrappedTransaction = pgTx;
    }
    query(sql, params) {
        return this.wrappedTransaction.unsafe(sql, params);
    }
}
/**
 * Implements the `DBConnection` interface needed by PushProcessor for the
 * postgres.js library.
 */
export class PostgresJSConnection {
    #pg;
    constructor(pg) {
        this.#pg = pg;
    }
    query(sql, params) {
        return this.#pg.unsafe(sql, params);
    }
    transaction(fn) {
        return this.#pg.begin(pgTx => fn(new Transaction(pgTx)));
    }
}
//# sourceMappingURL=postgresjs-connection.js.map