import type { ServerSchema } from '../../z2s/src/schema.ts';
import type { Schema } from '../../zero-schema/src/builder/schema-builder.ts';
import type { DBTransaction } from '../../zql/src/mutate/custom.ts';
export type ServerSchemaRow = {
    schema: string;
    table: string;
    column: string;
    type: string;
    length: string | null;
    precision: string | null;
    scale: string | null;
    enum: string;
    enumtype: string;
};
export declare function getServerSchema<S extends Schema>(dbTransaction: DBTransaction<unknown>, schema: S): Promise<ServerSchema>;
export type SchemaIncompatibilityError = {
    type: 'typeError';
    table: string;
    column: string;
    pgType: string;
    declaredType: string;
    requiredType: string | undefined;
} | {
    type: 'missingColumn';
    table: string;
    column: string;
} | {
    type: 'missingTable';
    table: string;
};
export declare function checkSchemasAreCompatible(schema: Schema, serverSchema: ServerSchema): SchemaIncompatibilityError[];
//# sourceMappingURL=schema.d.ts.map