import * as v from '../../shared/src/valita.ts';
export declare const downstreamSchema: v.UnionType<[v.TupleType<[v.Type<"connected">, v.ObjectType<{
    wsid: v.Type<string>;
    timestamp: v.Optional<number>;
}, undefined>]>, v.Type<import("./error.ts").ErrorMessage>, v.TupleType<[v.Type<"pong">, v.ObjectType<{}, undefined>]>, v.TupleType<[v.Type<"pokeStart">, v.ObjectType<{
    pokeID: v.Type<string>;
    baseCookie: v.UnionType<[v.Type<string>, v.Type<null>]>;
    schemaVersions: v.Optional<{
        minSupportedVersion: number;
        maxSupportedVersion: number;
    }>;
    timestamp: v.Optional<number>;
}, undefined>]>, v.TupleType<[v.Type<"pokePart">, v.ObjectType<{
    pokeID: v.Type<string>;
    lastMutationIDChanges: v.Optional<Record<string, number>>;
    desiredQueriesPatches: v.Optional<Record<string, ({
        ttl?: number | undefined;
        op: "put";
        hash: string;
        ast: import("./ast.ts").AST;
    } | {
        op: "del";
        hash: string;
    } | {
        op: "clear";
    })[]>>;
    gotQueriesPatch: v.Optional<({
        ttl?: number | undefined;
        op: "put";
        hash: string;
        ast: import("./ast.ts").AST;
    } | {
        op: "del";
        hash: string;
    } | {
        op: "clear";
    })[]>;
    rowsPatch: v.Optional<({
        op: "put";
        tableName: string;
        value: Readonly<Record<string, import("../../shared/src/json.ts").ReadonlyJSONValue | undefined>>;
    } | {
        merge?: import("../../shared/src/json.ts").ReadonlyJSONObject | undefined;
        constrain?: string[] | undefined;
        op: "update";
        tableName: string;
        id: Readonly<Record<string, string | number | boolean>>;
    } | {
        op: "del";
        tableName: string;
        id: Readonly<Record<string, string | number | boolean>>;
    } | {
        op: "clear";
    })[]>;
}, undefined>]>, v.TupleType<[v.Type<"pokeEnd">, v.ObjectType<{
    pokeID: v.Type<string>;
    cookie: v.Type<string>;
    cancel: v.Optional<boolean>;
}, undefined>]>, v.TupleType<[v.Type<"pull">, v.ObjectType<{
    cookie: v.Type<string>;
    requestID: v.Type<string>;
    lastMutationIDChanges: v.Type<Record<string, number>>;
}, undefined>]>, v.TupleType<[v.Type<"deleteClients">, v.UnionType<[v.ObjectType<Readonly<{
    clientIDs: v.Optional<readonly string[]>;
    clientGroupIDs: v.Optional<readonly string[]>;
}>, undefined>]>]>, v.TupleType<[v.Type<"pushResponse">, v.UnionType<[v.ObjectType<{
    mutations: v.ArrayType<v.ObjectType<{
        id: v.ObjectType<{
            id: v.Type<number>;
            clientID: v.Type<string>;
        }, undefined>;
        result: v.UnionType<[v.ObjectType<{
            data: v.Optional<import("../../shared/src/json.ts").ReadonlyJSONValue>;
        }, undefined>, v.UnionType<[v.ObjectType<{
            error: v.Type<"app">;
            details: v.Optional<import("../../shared/src/json.ts").ReadonlyJSONValue>;
        }, undefined>, v.ObjectType<{
            error: v.Type<"oooMutation" | "alreadyProcessed">;
            details: v.Optional<import("../../shared/src/json.ts").ReadonlyJSONValue>;
        }, undefined>]>]>;
    }, undefined>>;
}, undefined>, v.UnionType<[v.ObjectType<{
    error: v.Type<"unsupportedPushVersion">;
    mutationIDs: v.Optional<{
        id: number;
        clientID: string;
    }[]>;
}, undefined>, v.ObjectType<{
    error: v.Type<"unsupportedSchemaVersion">;
    mutationIDs: v.Optional<{
        id: number;
        clientID: string;
    }[]>;
}, undefined>, v.ObjectType<{
    error: v.Type<"http">;
    status: v.Type<number>;
    details: v.Type<string>;
    mutationIDs: v.Optional<{
        id: number;
        clientID: string;
    }[]>;
}, undefined>, v.ObjectType<{
    error: v.Type<"zeroPusher">;
    details: v.Type<string>;
    mutationIDs: v.Optional<{
        id: number;
        clientID: string;
    }[]>;
}, undefined>]>]>]>, v.TupleType<[v.Type<"inspect">, v.UnionType<[v.ObjectType<{
    op: v.Type<"queries">;
    id: v.Type<string>;
    value: v.ArrayType<v.ObjectType<{
        clientID: v.Type<string>;
        queryID: v.Type<string>;
        ast: v.Type<import("./ast.ts").AST>;
        got: v.Type<boolean>;
        deleted: v.Type<boolean>;
        ttl: v.Type<number>;
        inactivatedAt: v.Type<number | null>;
        rowCount: v.Type<number>;
    }, undefined>>;
}, undefined>]>]>]>;
export type Downstream = v.Infer<typeof downstreamSchema>;
//# sourceMappingURL=down.d.ts.map