import * as v from '../../shared/src/valita.ts';
export declare const pullRequestBodySchema: v.ObjectType<{
    clientGroupID: v.Type<string>;
    cookie: v.UnionType<[v.Type<string>, v.Type<null>]>;
    requestID: v.Type<string>;
}, undefined>;
export declare const pullResponseBodySchema: v.ObjectType<{
    cookie: v.Type<string>;
    requestID: v.Type<string>;
    lastMutationIDChanges: v.Type<Record<string, number>>;
}, undefined>;
export declare const pullRequestMessageSchema: v.TupleType<[v.Type<"pull">, v.ObjectType<{
    clientGroupID: v.Type<string>;
    cookie: v.UnionType<[v.Type<string>, v.Type<null>]>;
    requestID: v.Type<string>;
}, undefined>]>;
export declare const pullResponseMessageSchema: v.TupleType<[v.Type<"pull">, v.ObjectType<{
    cookie: v.Type<string>;
    requestID: v.Type<string>;
    lastMutationIDChanges: v.Type<Record<string, number>>;
}, undefined>]>;
export type PullRequestBody = v.Infer<typeof pullRequestBodySchema>;
export type PullResponseBody = v.Infer<typeof pullResponseBodySchema>;
export type PullRequestMessage = v.Infer<typeof pullRequestMessageSchema>;
export type PullResponseMessage = v.Infer<typeof pullResponseMessageSchema>;
//# sourceMappingURL=pull.d.ts.map