import { type Accessor } from 'solid-js';
import { type HumanReadable, type Query, type Schema, type TTL } from '../../zero/src/zero.ts';
import { type QueryResultDetails } from './solid-view.ts';
export type QueryResult<TReturn> = readonly [
    Accessor<HumanReadable<TReturn>>,
    Accessor<QueryResultDetails>
];
export type CreateQueryOptions = {
    ttl?: TTL | undefined;
};
/**
 * @deprecated Use {@linkcode CreateQueryOptions} instead.
 */
export type UseQueryOptions = {
    ttl?: TTL | undefined;
};
export declare function createQuery<TSchema extends Schema, TTable extends keyof TSchema['tables'] & string, TReturn>(querySignal: () => Query<TSchema, TTable, TReturn>, options?: CreateQueryOptions | Accessor<CreateQueryOptions>): QueryResult<TReturn>;
/**
 * @deprecated Use {@linkcode createQuery} instead.
 */
export declare function useQuery<TSchema extends Schema, TTable extends keyof TSchema['tables'] & string, TReturn>(querySignal: () => Query<TSchema, TTable, TReturn>, options?: CreateQueryOptions | Accessor<CreateQueryOptions>): QueryResult<TReturn>;
//# sourceMappingURL=create-query.d.ts.map