import { type Change, type Format, type HumanReadable, type Input, type Output, type Query, type ResultType, type Schema, type TTL } from '../../zero-client/src/mod.js';
export type QueryResultDetails = {
    readonly type: ResultType;
};
export declare class SolidView<V> implements Output {
    #private;
    constructor(input: Input, onTransactionCommit: (cb: () => void) => void, format: Format, onDestroy: () => void, queryComplete: true | Promise<true>, updateTTL: (ttl: TTL) => void);
    get data(): V;
    get resultDetails(): QueryResultDetails;
    destroy(): void;
    push(change: Change): void;
    updateTTL(ttl: TTL): void;
}
export declare function solidViewFactory<TSchema extends Schema, TTable extends keyof TSchema['tables'] & string, TReturn>(_query: Query<TSchema, TTable, TReturn>, input: Input, format: Format, onDestroy: () => void, onTransactionCommit: (cb: () => void) => void, queryComplete: true | Promise<true>, updateTTL: (ttl: TTL) => void): SolidView<HumanReadable<TReturn>>;
//# sourceMappingURL=solid-view.d.ts.map