import type { Row } from '../../../zero-protocol/src/data.ts';
import type { Change } from './change.ts';
import type { Node } from './data.ts';
import type { FetchRequest, Input, Output } from './operator.ts';
export type CaughtNode = {
    row: Row;
    relationships: Record<string, CaughtNode[]>;
};
export type CaughtAddChange = {
    type: 'add';
    node: CaughtNode;
};
export type CaughtRemoveChange = {
    type: 'remove';
    node: CaughtNode;
};
export type CaughtChildChange = {
    type: 'child';
    row: Row;
    child: {
        relationshipName: string;
        change: CaughtChange;
    };
};
export type CaughtEditChange = {
    type: 'edit';
    oldRow: Row;
    row: Row;
};
export type CaughtChange = CaughtAddChange | CaughtRemoveChange | CaughtChildChange | CaughtEditChange;
/**
 * Catch is an Output that collects all incoming stream data into arrays. Mainly
 * useful for testing.
 */
export declare class Catch implements Output {
    #private;
    readonly pushes: CaughtChange[];
    readonly pushesWithFetch: {
        change: CaughtChange;
        fetch: CaughtNode[];
    }[];
    constructor(input: Input, fetchOnPush?: boolean);
    fetch(req?: FetchRequest): CaughtNode[];
    cleanup(req?: FetchRequest): CaughtNode[];
    push(change: Change): void;
    reset(): void;
    destroy(): void;
}
export declare function expandChange(change: Change): CaughtChange;
export declare function expandNode(node: Node): CaughtNode;
//# sourceMappingURL=catch.d.ts.map