import type { Change } from './change.ts';
import type { FanIn } from './fan-in.ts';
import type { Node } from './data.ts';
import type { FilterInput, FilterOperator, FilterOutput } from './filter-operators.ts';
/**
 * Forks a stream into multiple streams.
 * Is meant to be paired with a `FanIn` operator which will
 * later merge the forks back together.
 */
export declare class FanOut implements FilterOperator {
    #private;
    constructor(input: FilterInput);
    setFanIn(fanIn: FanIn): void;
    setFilterOutput(output: FilterOutput): void;
    destroy(): void;
    getSchema(): import("./schema.ts").SourceSchema;
    filter(node: Node, cleanup: boolean): boolean;
    push(change: Change): void;
}
//# sourceMappingURL=fan-out.d.ts.map