import type { JSONValue } from '../../../shared/src/json.ts';
import type { Storage } from './operator.ts';
import type { Stream } from './stream.ts';
/**
 * MemoryStorage is a simple in-memory implementation of `Storage` for use
 * on the client and in tests.
 */
export declare class MemoryStorage implements Storage {
    #private;
    set(key: string, value: JSONValue): void;
    get(key: string, def?: JSONValue): JSONValue | undefined;
    del(key: string): void;
    scan(options?: {
        prefix: string;
    }): Stream<[string, JSONValue]>;
    cloneData(): Record<string, JSONValue>;
}
//# sourceMappingURL=memory-storage.d.ts.map