import type { Ordering, System } from '../../../zero-protocol/src/ast.ts';
import type { PrimaryKey } from '../../../zero-protocol/src/primary-key.ts';
import type { SchemaValue } from '../../../zero-schema/src/table-schema.ts';
import type { Comparator } from './data.ts';
/**
 * Information about the nodes output by an operator.
 */
export type SourceSchema = {
    readonly tableName: string;
    readonly columns: Record<string, SchemaValue>;
    readonly primaryKey: PrimaryKey;
    readonly relationships: {
        [key: string]: SourceSchema;
    };
    readonly isHidden: boolean;
    readonly system: System;
    readonly compareRows: Comparator;
    readonly sort: Ordering;
};
//# sourceMappingURL=schema.d.ts.map