import type { Row } from '../../../zero-protocol/src/data.ts';
import type { Change } from './change.ts';
import type { Node } from './data.ts';
import { type FetchRequest, type Input, type Operator, type Output } from './operator.ts';
import type { SourceSchema } from './schema.ts';
import type { Stream } from './stream.ts';
export type Bound = {
    row: Row;
    exclusive: boolean;
};
/**
 * Skip sets the start position for the pipeline. No rows before the bound will
 * be output.
 */
export declare class Skip implements Operator {
    #private;
    constructor(input: Input, bound: Bound);
    getSchema(): SourceSchema;
    fetch(req: FetchRequest): Stream<Node>;
    cleanup(req: FetchRequest): Stream<Node>;
    setOutput(output: Output): void;
    destroy(): void;
    push(change: Change): void;
}
//# sourceMappingURL=skip.d.ts.map