/**
 * streams are lazy forward-only iterables.
 * Once a stream reaches the end it can't be restarted.
 * They are iterable, not iterator, so that they can be used in for-each,
 * and so that we know when consumer has stopped iterating the stream. This allows us
 * to clean up resources like sql statements.
 */
export type Stream<T> = Iterable<T>;
export declare function take<T>(stream: Stream<T>, limit: number): Stream<T>;
export declare function first<T>(stream: Stream<T>): T | undefined;
//# sourceMappingURL=stream.d.ts.map