import baseSql from '@databases/sql';
import { escapeSQLiteIdentifier } from '@databases/escape-identifier';
const sqliteFormat = {
    escapeIdentifier: str => escapeSQLiteIdentifier(str),
    formatValue: value => ({ placeholder: '?', value }),
};
export function compile(sql) {
    return sql.format(sqliteFormat).text;
}
export function format(sql) {
    return sql.format(sqliteFormat);
}
export const sql = baseSql.default;
//# sourceMappingURL=sql.js.map