export const runtimeDebugFlags = {
    trackRowsVended: false,
};
const rowsVendedByCg = new Map();
export const runtimeDebugStats = {
    rowVended(clientGroupID, source, query) {
        let sourceMap = rowsVendedByCg.get(clientGroupID);
        if (!sourceMap) {
            sourceMap = new Map();
            rowsVendedByCg.set(clientGroupID, sourceMap);
        }
        let queryMap = sourceMap.get(source);
        if (!queryMap) {
            queryMap = new Map();
            sourceMap.set(source, queryMap);
        }
        queryMap.set(query, (queryMap.get(query) ?? 0) + 1);
    },
    resetRowsVended(clientGroupID) {
        rowsVendedByCg.delete(clientGroupID);
    },
    getRowsVended(clientGroupID) {
        return rowsVendedByCg.get(clientGroupID);
    },
    all() {
        return rowsVendedByCg;
    },
};
//# sourceMappingURL=runtime-debug.js.map